## -*- asm -*- ##############################################################
#                                                                           #
#                 GNAT RUN-TIME LIBRARY (GNARL) COMPONENTS                  #
#                                                                           #
#                        C O N T E X T _ S W I T C H                        #
#                                                                           #
#                               Assembly File                               #
#                                                                           #
#                         Copyright (C) 2012 AdaCore                        #
#                                                                           #
#  GNAT is free software;  you can  redistribute it  and/or modify it under #
#  terms of the  GNU General Public License as published  by the Free Soft- #
#  ware  Foundation;  either version 3,  or (at your option) any later ver- #
#  sion.  GNAT is distributed in the hope that it will be useful, but WITH- #
#  OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY #
#  or FITNESS FOR A PARTICULAR PURPOSE.                                     #
#                                                                           #
#  As a special exception under Section 7 of GPL version 3, you are granted #
#  additional permissions described in the GCC Runtime Library Exception,   #
#  version 3.1, as published by the Free Software Foundation.               #
#                                                                           #
#  You should have received a copy of the GNU General Public License and    #
#  a copy of the GCC Runtime Library Exception along with this program;     #
#  see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    #
#  <http://www.gnu.org/licenses/>.                                          #
#                                                                           #
#############################################################################

	.syntax unified
	.cpu cortex-m3
	.thumb

	.text

	.thumb_func
	.globl context_switch
context_switch:
	@ ip = running thread context
        ldr     ip, Lrun
        ldr     ip, [ip]

        @ Save context
        stmia   ip!, {r4-r11,lr}
	str	sp,[ip]

        @ Running thread = first_thread
        ldr     ip, Lfirst
        ldr     ip, [ip]
        ldr     r0, Lrun
        str     ip, [r0]

        @ Restore context
        ldmia   ip!, {r4-r11,lr}
	ldr	sp,[ip]
        bx	lr

        .align 2
Lrun:
        .word   __gnat_running_thread_table
Lfirst:
        .word   first_thread_table

	.size context_switch, . - context_switch

	.thumb_func
	.globl start_thread_asm
start_thread_asm:
	mov	r0,r5
	blx	r4
0:	b	0b

	.size start_thread_asm, . - start_thread_asm
